rem HTMLEDIT a set of macros to ease editing of HTML-files on
rem Psion Series 3a (probably also on 3c and Siena) palmtop computers.
rem Requires the MACSYS macro system, tested with version 2.0.

rem Version 0.9, May 1997
rem by Martin Stut, Marburg, Germany, email:martin.stut@iname.com
rem http://www.geocities.com/ResearchTriangle/8154/psion.htm
rem May be freely used and redistributed. 
rem If you make improvements and modifications (e.g. for an english Psion)
rem please send me a copy, so that I can include the changes for others.

rem Installation: 
rem If you have not done it yet, get and install macsys.
rem Copy the *.mcr files into the MCR directory (on my Psion: \macro\mcr).
rem If you have a non-german Psion, adapt a few keycodes in htmledit.mcr.
rem Translate htmledit.mcr, resulting in htmledit.mco.
rem Create or open a macro database (I use htmledit.mdb).
rem Install htmledit.mco as a macro and assign it to a hotkey (I use ctrl-shift-1).

rem The functions web2word and word2web require a file based HTM-browser.
rem I tested it with websurf V1.72, but if you have another one,
rem you only need to adapt the PROCs web2word and word2web.

rem Usage:
rem After pressing the hotkey (e.g. ctrl-shift-1), you have several
rem additional hotkeys (see PROC macro:)

rem If you need special characters (like german umlauts),
rem do the same with htmluml.mcr/mco.

PROC macro:
rem invoked by MACSYS hotkey, e.g. ctrl-shift-1
Hotkey:(12, 6, "linkgen", 1) rem ctrl-shift-l, create links between every open *.htm-file (can take minutes)
Hotkey:(11, 6, "linkgen", 1) rem ctrl-shift-k, link the current file with all open *.htm-files and backward
Hotkey:(19, 6, "saveas", 1) rem ctrl-shift-s, save, but don't exit (=continue)
Hotkey:(24, 6, "saveas", 1) rem ctrl-shift-x, save and exit
Hotkey:(8, 6, "hunt", 1) rem ctrl-shift-h, hunt (follow) next (current search direction) html link
rem the following commands require proc webdir$ to be adjusted.
Hotkey:(23, 6, "web2word", 1) rem ctrl-shift-w, switch from web-browser (websurf) to word-editor, designed to immediately modify the file you just viewed
Hotkey:(2, 6, "word2web", 1) rem ctrl-shift-b, switch from word-editor to web-browser (websurf), designed to preview the file you just edited
Hotkey:(10, 6, "newfile", 1) rem ctrl-shift-j, create new file and link it to current one

ENDP

rem ====================================================
rem ----> Modify here to reflect your directory structure.
rem returns the Directory where web2word and word2web will look for and store files.
rem This value is used in several places, so it is stored at a central location here.
rem IMPORTANT: INCLUDE the TRAILING BACKSLASH
PROC webdir$:
rem	return("\WWW\DGDHOME\")
	return("\WRD\HTM\")
ENDP

rem ====================================================
rem Save current file. If it has the extension .htm, then it is saved as text, not as word.
rem If the first parameter (supplied by the Hotkey: function in macsys)
rem is the code for "x", then it will also exit.
rem There seems to be a bug in the exiting variant: 
rem  if there were changes to n htm-file after the last save, 
rem  then it saves in word format, not text format.
rem  Workaround: save without exit before you exit.
rem  I tried a lot, but in vain. Does anybody have a solution?

PROC saveas:(k%,m%)

local cpid%
local cfnam$(20)

UseApp:( "Word" )
ToFront:
cpid% = CurrPid%:
cfnam$ = Pid2Fil$:(cpid%)
rem GIprint:(right$(cfnam$,4)) rem seems to disturb the exit - file still locked when browser tries to open it
SendKey:(627,8,1) rem Psion-S, "save" in German Psion, to avoid later complaints when exiting the file
IF right$(cfnam$,4)=".HTM"
	rem ----> modify the next line for non-German Psions
	SendKey:(629,8,1) rem Psion-U, "save as" in German Psion
	SendText:( cfnam$ )
	SendKey:(257,0,3) rem 3 times Down
	SendKey:(116,0,1) rem T, make sure it'll be TEXT type
	SendKey:(13,0,1) rem Enter
	rem ----> modify the next line for non-German Psions
	SendKey:(106,0,1) rem J, Ja (Yes),DO overwrite
ELSE
ENDIF
IF k%=24 rem X pressed => leave after saving
	Kill: rem Kill seems to be too harsh: Application has no time to REALLY save in text format
ENDIF
ENDP

rem ====================================================
rem -- LINK - Written by Martin Stut
rem -- based on "Tasklist" by Tom Dolbilin

rem -- This macro will link the currently active HTM-file (kcod%=11)
rem -- or all currently open ones (kcod%=12)
rem -- with all open ones, adding the title as link explanation.

PROC linkgen:(kcod%,kmod%)
local doall%
local i%
local j%
local pid%(25)
local t$(25), task$(22,15), tit$(255), tit2$(255)
local d%
local n% rem number of *.htm tasks
local cpid% rem Process-Id of current file
local cfnam$(25) rem name of current file
local cnr% rem number of current file in array 

IF kcod%=12
	doall%=1
ELSEIF kcod%=11
	doall%=0
ELSE
	Giprint:("Illegal keycode")
ENDIF
rem cache on

rem - create list of all active htm-files

UseApp:( "Word" )
cpid% = CurrPid%:
rem cfnam$ = Pid2Fil$:(cpid%)
GiPrint:( "Building list..." )
call( $d98d, 0, 0, 0, addr( pid%() ) )
i% = 1
n% = 0
cnr% = 0
WHILE pid%(i%)
	t$ = Lower$(Pid2Fil$:(pid%(i%)))
	IF right$(t$,4)=".htm"
		n%=n%+1
		task$(n%)=t$
		IF pid%(i%) = cpid%
			cnr% = n%
		ENDIF
		GiPrint:("task = "+t$)
	ENDIF
	i%=i%+1
ENDWH

rem - in each htm file insert an (empty-texted)
rem - link to all the other ones

i%=1 rem file where the link is inserted
WHILE i% <= n%
	UseFile:(task$(i%))
	ToFront:
	SendKey:(262,8,1) rem Psion Home to jump to start of line
	j%=1 rem loop through the files where the link will be pointing to
	WHILE j% <= n%
		IF DoLink%:(i%,j%,cnr%,doall%) <> 0
			SendText:(link$:(task$(j%),"")+CHR$(13))
		ENDIF
		j%=j%+1
	ENDWH
	i%=i%+1
ENDWH

rem - get the title of each htm file
i%=1
WHILE i%<=n%
	tit$=getTit$:(task$(i%))
	rem - in each file fill the empty links 
	rem - with the title of the link
	j%=1
	WHILE j%<=n%
		IF DoLink%:(i%,j%,cnr%, doall%) rem no link to self needed
			rem sere = search & replace in task Par1, par2 by par3
			UseFile:(task$(j%))
			ToFront:
			sere:(link$:(task$(i%),""),link$:(task$(i%),tit$))
		ENDIF
		j%=j%+1
	ENDWH
	i%=i%+1
ENDWH

GiPrint:( "Finished." )
ENDP

rem -------------------------------------------------------------
rem returns the full string to be inserted as an anchor

PROC link$:(filnam$,tit$)
	return("<A HREF="+CHR$(34)+Lower$(filnam$)+CHR$(34)+">"+tit$+"</A>")
ENDP

rem -------------------------------------------------------------
rem returns the HTML-Title of the named file

PROC getTit$:(filnam$)
rem get the HTML Title of file filnam$
local srcpid%, l%
local x$(255)
UseFile:(filnam$)
ToFront:
SendKey:(260,12,1) rem Ctrl-Psion-Up, goto beginning of file
Search:("<TITLE>")
right: rem skip past the title
SendKey:(right%, shift%, 100)	rem 100 characters should be long enough for the file name...
x$ = GetSel$: rem get the selection just done
Left: rem unmark the marked area (just to clean up and avoid accidents)
l%=loc(x$,"</TITLE>")
x$=Left$(x$,l%-1)
return(x$)
ENDP

rem -------------------------------------------------------------
rem search and replace in current file

PROC SeRe:(se$,re$)
local done%, f$(255)
SendKey:(260,12,1) rem Ctrl-Psion-Up, goto beginning of file
DO
	Search:(se$)
	f$=GetSel$:
	IF f$=se$
		SendText:(re$)
		rem done%=0
		done%=1 rem no solution yet to detect "not found", so quit after the first...
	ELSE
		done%=1
	ENDIF
UNTIL done%=1
ENDP

rem -------------------------------------------------------------
rem search for x$ in current file, starting at current position

PROC Search:(x$)
rem ----> modify here for non-german psions
SendKey:(614,8,1) rem Psion-F, find in german 3a
SendText:(x$)
Enter:
ENDP

rem -------------------------------------------------------------
rem get the selection just done (this code was copied from bracket.mcr by some other author)
rem but don't leave (return to) application 

PROC GetSel$:
local x$(255), srcpid%
srcpid% = CurrPid%:
ToMacro:
x$ = GetText$:
UsePid:(srcpid%)
return(x$)
ENDP

rem -------------------------------------------------------------
rem Figure out whether a link from array position i% to j% is
rem needed, given that cnr% is the main page.
rem If doall%=1, then each is bidirectionally linked with each other,
rem otherwise only cnr% is linked bidirectionally linked with each other.

PROC DoLink%:(i%,j%,cnr%, doall%)
	IF (i% = cnr%) OR (doall%=1) rem the main page, link to all needed
		iF j% <> i% rem no link to self needed
			return(1)
		ENDIF
	ELSE rem not main page, only link to cnr needed
		IF j% = cnr%
			return(1)
		ENDIF
	ENDIF
	return(0)
ENDP

rem ====================================================
rem macro for macsys to follow a hypertext link

PROC hunt:(kcod%,kmod%)

local x$(255), f$(255), s$(255) rem the file to be jumped at
local e$(10), i$(10), l%, i%
local srcpid%
local destpid%
rem pid of the originator

UseApp:("Active")

rem Find the next anchor
Search:("<A HREF=")
x$ = GetSel$:
IF x$ =  "<A HREF="
	rem Select the filename to jump to
	Right:
	SendKey:(right%, shift%, 40)	rem 40 characters should be long enough for the file name...
	x$ = GetSel$: rem get the selection just done
	Left: rem unmark the marked area (just to clean up and avoid accidents)
	rem extract the filename
		rem cut off leading garbage
	l%=loc(x$,">")-1 rem can't be longer
	IF l%>0
		x$=Left$(x$,l%)
		IF Left$(x$,1)=CHR$(34)
			l%=l%-2
			x$=Mid$(x$,2,l%) rem cut off the quotes
		ENDIF
		GiPrint:(x$)
	ELSE
		GiPrint:("No tag found.")
	ENDIF
	
		rem copy the good stuff to f$
	f$=""
	WHILE charfnam:(mid$(x$,1,1))=1
		e$=Mid$(x$,1,1)
		if e$="/"
			e$="\"
		elseif e$=chr$(34)
			e$=""
		endif
		f$=f$+e$
		x$=Mid$(x$,2,l%)
	ENDWH
	
	s$=""	rem set s$ to an eventual search string (name) within the file
	IF Mid$(x$,1,1)="#"
		x$=Mid$(x$,2,l%)
		WHILE charfnam:(mid$(x$,1,1))=1
			s$=s$+Mid$(x$,1,1)
			x$=Mid$(x$,2,l%)
		ENDWH
	ENDIF
	
	IF len(f$)>=5 AND lower$(Right$(f$,4))=".htm"
		rem execute the jump
		Giprint("Jumping to:"+f$+".")
		RunAppC:("word", webdir$: + f$)
		rem if necessary, jump to named anchor
		if len(s$)>0
			SendKey:(262,12,1)	rem Psion-Ctrl-Home
			rem ----> modify here for non-german psions
			SendKey:(614,8,1) rem Psion-F, find in german 3a
			rem direction of find is the current default - don't know of a way to control this
			SendText:("<A NAME="+CHR$(34)+s$)
			Enter:
			Right:	rem deselect the place found
		endif
	ELSE
		GiPrint:("No valid filename after HREF.")
	ENDIF
ELSE
	GiPrint:("No anchor found.")
ENDIF

ENDP

rem -------------------------------------------------------------
rem returns 1 if c$ is a valid character in a filename, 0 otherwise

PROC charfnam:(x$)
	local c$(1)
	c$=x$
	IF C$>="A" and c$<="Z"
		RETURN (1)
	ELSEIF C$>="a" and c$<="z"
		RETURN (1)
	ELSEIF C$>="0" and c$<="9"
		RETURN (1)
	ELSEIF C$="_" or c$="." or c$="-" or c$="\" or c$="/"
		RETURN (1)
	ELSE
		RETURN (0)
	ENDIF
ENDP

rem ====================================================
rem closes the current word application and switches to WEB-view

PROC word2web:(k%,m%)
local cpid%
local cfnam$(40)
UseApp:( "Word" )
cpid% = CurrPid%:
cfnam$ = Pid2Fil$:(cpid%)
saveas:(24,6)	rem save & exit the HTM file
ToMacro: rem perhaps this helps to make the save-process finish orderly?
RunApp:("htmlview", webdir$: + cfnam$)
UseApp:("htmlview")
rem RunApp:("websurf", webdir$: + cfnam$)
rem UseApp:("websurf")
rem Enter: rem Enter: is not supported by Websurf (to blank the registration reminder dialogue)
ENDP

rem ====================================================
rem closes the current web application and switches to WORD-view

PROC web2word:(k%,m%)
local cpid%
local cfnam$(40)
UseApp:( "htmlview" )
rem UseApp:( "websurf" )
cpid% = CurrPid%:
cfnam$ = Pid2Fil$:(cpid%)
Kill: rem exit the browser
RunApp:("word", webdir$: + cfnam$)
UseApp:("word")
ENDP

rem ====================================================
rem macro for macsys to create a new file and link it to the current one

PROC newfile:(kcod%,kmod%)

local nf$(50) rem the name of the file to be created
local nt$(50) rem the title of the new file
local dret%
local cpid%
local of$(100) rem the name of the old/current file
local ot$(100) rem the title of the old/current file

UseApp:("Active")

cpid% = CurrPid%:
of$ = Pid2Fil$:(cpid%)

nf$="Name of new file (incl. .htm)"
dInit:("Name of the new file:")
dEdit:(addr(nf$),"Filename:",50)
dret%=Dialog:
IF dret%<>1
  RETURN (1)
ENDIF

nt$="Title of new file"
dInit:("Title of "+nf$+":")
dEdit:(addr(nt$),"Title:",50)
dret%=Dialog:
IF dret%<>1
  RETURN (1)
ENDIF

rem insert link in old file
SendText:(link$:(nf$,nt$)+CHR$(13))

rem get (search) title of old file; this is done after inserting the links
rem  because this moves the cursor
ot$=getTit$:(of$)

rem execute the jump
nf$=webdir$: + nf$
Giprint("Jumping to:"+nf$+".")
RunAppC:("word",nf$)
SendText:("<HTML><HEAD><TITLE>"+nt$+"</TITLE></HEAD>"+CHR$(13))
SendText:("<BODY>Back to "+link$:(of$,ot$)+"<HR>"+CHR$(13)+"</BODY></HTML>")

ENDP


