rem HTMLUML a set of macros to ease entering German Umlauts in HTML-files on
rem Psion Series 3a (probably also on 3c and Siena) palmtop computers.
rem Requires the MACSYS macro system, tested with version 2.0.

rem Version 1.0, May 1997
rem by Martin Stut, Marburg, Germany, email:martin.stut@iname.com
rem http://www.geocities.com/ResearchTriangle/8154/psion.htm
rem May be freely used and redistributed. 
rem If you make improvements and modifications (e.g. for an english Psion)
rem please send me a copy, so that I can include the changes for others.

rem Installation: 
rem If you have not done it yet, get and install macsys.
rem Copy the *.mcr files into the MCR directory (on my Psion: \macro\mcr).
rem If you have a non-german Psion, you may have to adapt a few keycodes.
rem Translate htmluml.mcr, resulting in htmluml.mco.
rem Create or open a macro database (I use htmledit.mdb).
rem Install htmluml.mco as a macro and assign it to a hotkey (I use ctrl-shift-2).

rem Usage:
rem After pressing the hotkey (e.g. ctrl-shift-2), the keys of the Umlauts
rem behave differently: instead of entering the Umlaut, its HTML-code is entered.
rem If you want to turn this off, press ctrl-shift-0, which disables the hotkeys.

PROC macro:
Hotkey:(132, 4, "umlins", 1) rem ctrl-* = 
Hotkey:(148, 4, "umlins", 1) rem ctrl-- = 
Hotkey:(129, 4, "umlins", 1) rem ctrl-+ = 
Hotkey:(142, 6, "umlins", 1) rem ctrl-shift-* = 
Hotkey:(153, 6, "umlins", 1) rem ctrl-shift-- = 
Hotkey:(154, 6, "umlins", 1) rem ctrl-shift-+ = 
Hotkey:(225, 2, "umlins", 1) rem shift-/ = 
Hotkey:(34, 2, "umlins", 1) rem shift-2 = "
Hotkey:(38, 2, "umlins", 1) rem shift-6 = &
Hotkey:(60, 2, "umlins", 1) rem shift-+ = <
Hotkey:(62, 2, "umlins", 1) rem shift-* = >

Hotkey:(48, 6, "hkoff", 1) rem ctrl-shift-0 = switch off hotkeys
ENDP

rem ====================================================
rem inserts (by calling SendText:) the HTML-code corresponding to the keycode. 
rem Designed to match german Umlauts on a german Psion 3a

PROC umlins:(k%,m%)

UseApp:("Active")
IF m%=4 rem Ctrl
	IF k%=132
		SendText:("&auml;")
	ELSEIF k%=148
		SendText:("&ouml;")
	ELSEIF k%=129
		SendText:("&uuml;")
	ENDIF
ELSEIF m%=6 rem Shift-Ctrl
	IF k%=142
		SendText:("&Auml;")
	ELSEIF k%=153
		SendText:("&Ouml;")
	ELSEIF k%=154
		SendText:("&Uuml;")
	ENDIF
ELSEIF m%=2 rem Shift only
	IF k%=225
		SendText:("&szlig;")
	ELSEIF k%=34
		SendText:("&quot;")
	ELSEIF k%=38
		SendText:("&amp;")
	ELSEIF k%=60
		SendText:("&lt;")
	ELSEIF k%=62
		SendText:("&gt;")
	ENDIF
ENDIF
ENDP

rem ====================================================
rem switches off the hotkeys (e.g. if you want to type standard Umlauts in word)

PROC hkoff:(k%,m%)
Hotkey:(132, 4, "umlins", 0) rem ctrl-* = 
Hotkey:(148, 4, "umlins", 0) rem ctrl-- = 
Hotkey:(129, 4, "umlins", 0) rem ctrl-+ = 
Hotkey:(142, 6, "umlins", 0) rem ctrl-shift-* = 
Hotkey:(153, 6, "umlins", 0) rem ctrl-shift-- = 
Hotkey:(154, 6, "umlins", 0) rem ctrl-shift-+ = 
Hotkey:(225, 2, "umlins", 0) rem shift-/ = 
Hotkey:(34, 2, "umlins", 0) rem shift-2 = "
Hotkey:(38, 2, "umlins", 0) rem shift-6 = &
Hotkey:(60, 2, "umlins", 0) rem shift-+ = <
Hotkey:(62, 2, "umlins", 0) rem shift-* = >

Hotkey:(48, 6, "hkoff", 0) rem ctrl-shift-0 = switch off hotkeys

ENDP
