rem TAG.MCR, macro to insert HTML-tags into HTM-files on
rem Psion Series 3a (probably also on 3c and Siena) palmtop computers.
rem Requires the MACSYS macro system, tested with version 2.0.

rem Version 1.0, May 1997
rem by Martin Stut, Marburg, Germany, email martin.stut@iname.com
rem http://www.geocities.com/ResearchTriangle/8154/
rem May be freely used and redistributed. 
rem If you make improvements and modifications (e.g. for an english Psion)
rem please send me a copy, so that I can include the changes for others.

rem Installation: 
rem If you have not done it yet, get and install macsys.
rem Copy the *.mcr files into the MCR directory (on my Psion: \macro\mcr).
rem Translate tag.mcr, resulting in tag.mco.
rem Create or open a macro database (I use htmledit.mdb).
rem Install tag.mco as a macro and assign it to a hotkey (I use ctrl-shift-T).

rem Usage:
rem While editing in Word, press the hotkey (e.g. ctrl-shift-T).
rem This opens a dialogue, where you can select different tags.
rem After pressing Enter the full tag will be inserted.

PROC macro:
local tt$(255) rem the string to be sent
UseApp:("Active") rem or "Word"
rem assumes that the text to be tagged is already marked
rem tt$="H1" rem try it with H1
tt$=SelTag$:
IF tt$>"!"
  rem make sure there is no selection that would be deleted
  left:
  right:
  SendText:(tt$)
  enter: rem a line break after the tag might be good to ensure it works at all
ENDIF
ENDP

rem select a valid HTML-tag
proc SelTag$:
local i,tags$(50,10), tagres$(50,100), tagcnt, dret
i=0
i=i+1:tags$(i)="P":tagres$(i)="<P>"
i=i+1:tags$(i)="A":tagres$(i)="<A HREF="+CHR$(34)+".htm"+CHR$(34)+"></A>"
i=i+1:tags$(i)="ADR":tagres$(i)="<ADDRESS></ADDRESS>"
i=i+1:tags$(i)="BR":tagres$(i)="<BR>"
i=i+1:tags$(i)="BOLD":tagres$(i)="<B></B>"
i=i+1:tags$(i)="DL":tagres$(i)="<DL><DT></DT><DD></DD>"+CHR$(13)+"</DL>"
i=i+1:tags$(i)="HR":tagres$(i)="<HR>"
i=i+1:tags$(i)="H1":tagres$(i)="<H1></H1>"
i=i+1:tags$(i)="H2":tagres$(i)="<H2></H2>"
i=i+1:tags$(i)="H3":tagres$(i)="<H3></H3>"
i=i+1:tags$(i)="H4":tagres$(i)="<H4></H4>"
i=i+1:tags$(i)="H5":tagres$(i)="<H5></H5>"
i=i+1:tags$(i)="H6":tagres$(i)="<H6></H6>"
i=i+1:tags$(i)="HTML":tagres$(i)="<HTML><HEAD><TITLE></TITLE></HEAD>"+CHR$(13)+"<BODY>"+CHR$(13)+"</BODY></HTML>"
i=i+1:tags$(i)="IMG":tagres$(i)="<IMG SRC="+CHR$(34)+CHR$(34)+">"
i=i+1:tags$(i)="LI":tagres$(i)="<LI></LI>"
i=i+1:tags$(i)="NAME":tagres$(i)="<A NAME="+CHR$(34)+CHR$(34)+"></A>"
i=i+1:tags$(i)="OL":tagres$(i)="<OL><LI></LI>"+CHR$(13)+"</OL>"
i=i+1:tags$(i)="PRE":tagres$(i)="<PRE>"+CHR$(13)+"</PRE>"
i=i+1:tags$(i)="STRONG":tagres$(i)="<STRONG></STRONG>"
i=i+1:tags$(i)="EM":tagres$(i)="<EM></EM>"
i=i+1:tags$(i)="UL":tagres$(i)="<UL><LI></LI>"+CHR$(13)+"</UL>"
dInit:("Select an HTML-Tag")
dchoiceA:(1,"Tag",addr(tags$()),0)
dret=Dialog:
IF dret<=0
  RETURN ("")
ELSE
  RETURN tagres$(dret)
ENDIF
ENDP
